
// Project: bottomwar 
// Created: 23-02-28
// IFM

#include "utils.agc"

// show all errors

SetErrorMode(2)

// set window properties
SetWindowTitle( "bottomwar" )
SetWindowSize( 400, 650, 0 )
SetWindowAllowResize( 1 ) // allow the user to resize the window

// set display properties
SetVirtualResolution( 720, 1366) // doesn't have to match the window
SetOrientationAllowed( 1, 1, 0, 0 ) // allow both portrait and landscape on mobile devices
SetSyncRate( 45, 0 ) // 30fps instead of 60 to save battery
SetScissor( 0,0,0,0 ) // use the maximum available screen space, no black borders
SetClearColor(123,20,55)
UseNewDefaultFonts( 1 )
//Clear after setting clearcolour
Sync()

//seed
SetRandomSeed(GetUnixTime())

function RandomEvent()
	r as integer[3,1]
	r[0,0] = 1000
	r[0,1] = Random(0,1)
	r[1,0] = Random(0,4)
	r[2,0] = Random(0,4)
	r[3,0] = Random(0,4)
	r[1,1] = Random(0,10)
	r[2,1] = Random(0,10)
	r[3,1] = Random(0,10)
endfunction r

//Friendly unit tracking
global units as integer []
//Hostile units tracking
global horde as integer []
//Middle lane of 3 by default (0 indexed)
global lane as integer = 1
//Event tracking: zposition (in [0,0]), numbers or enemies (in [0,1]), lane1[action,number], lane2, lane3. 5 sets tracked at any one time
global events as integer [4,3,1]
events[0] = RandomEvent()
events[0,0] = [200,0]
events[1] = RandomEvent()
events[1,0] = [400,0]
events[2] = RandomEvent()
events[2,0] = [600,0]
events[3] = RandomEvent()
events[3,0] = [800,0]
events[4] = RandomEvent()
//Scroll speed
global speed  as float = 0.05
//lane markers
global markers as integer [3]
//activemarker - object reference, animation count
global activemarker as integer [1]

//Position Camera (default 0,10,-20) Rotated 26.56 around X with FOV of 70
SetCameraPosition(1, 0.0, 10.0, -15.0)
SetCameraRotation(1,50.5,0.0,0.0)
SetCameraFOV(1,40)
//Create Floor
track = CreateObjectBox(9,1,30)

function NewUnit()
	units.insert(CreateObjectBox(0.25,0.25,0.25))
	SetObjectPosition(units[units.length], Random(0,8)-4, 1.0, -16.0)
	SetObjectColor(units[units.length], 10, 50, 230, 255)
endfunction

function NewHorde(l)
	horde.insert(CreateObjectCone(0.5,0.35,5))
	SetObjectPosition(horde[horde.length],(Random(0+l*29,30+l*29)-43)/10.0,1.0,16.0+Random(0,40)/10)
	SetObjectColor(horde[horde.length],200,130,20,255)
endfunction

menu:
AddVirtualButton(1, 360, 1000, 100)
SetVirtualButtonColor(1, 0, 255, 100)
SetVirtualButtonSize(1, 300,200)
SetVirtualButtonText(1, "START")
do
    Sync()
    //Play Button
    if GetVirtualButtonState(1)
    	DeleteVirtualButton(1)
    	//Add first unit
		NewUnit()
		//Add lane markers
		for i = 0 to 3
			markers[i] = CreateObjectBox(0.1,0.05,30)
			SetObjectPosition(markers[i], -4.5 + 3*i, 0.7, 0.0)
			SetObjectColor(markers[i], 50,50,50,255)
		next i
		activemarker[1] = 10
		activemarker[0] = CreateObjectBox(3.0,0.01,30)
		SetObjectPosition(activemarker[0], -3+lane*3,0.7,-30.0)
		SetObjectColor(activemarker[0], 100,180,255,10)
		CreateText(1, "_")
		CreateText(2, "_")
		CreateText(3, "_")
		SetTextPosition(1, 100,300)
		SetTextPosition(2, 300,300)
		SetTextPosition(3, 500,300)
		SetTextSize(1,150)
		SetTextSize(2,150)
		SetTextSize(3,150)
		SetTextColor(1,0,0,0,255)
		SetTextColor(2,0,0,0,255)
		SetTextColor(3,0,0,0,255)
    	goto play
    endif
loop
pause:
AddVirtualButton(1, 360, 1000, 100)
SetVirtualButtonColor(1, 0, 255, 100)
SetVirtualButtonSize(1, 300,200)
SetVirtualButtonText(1, "RESUME")
do
	Sync()
	if GetVirtualButtonState(1) 
		DeleteVirtualButton(1)
		goto play
	endif
loop

play:
//Populate UI
AddVirtualButton(1, 50, 1296, 100)
SetVirtualButtonColor(1, 255, 0, 100)
SetVirtualButtonSize(1, 100,100)
SetVirtualButtonText(1, "Pause")
do
	Sync()
	//Pause Button
	if GetVirtualButtonState(1)
		DeleteVirtualButton(1)
		goto pause
	endif
	//Lane change
	if GetPointerState() 
		lane = Round(GetPointerX()/(GetScreenBoundsRight()/2))
		SetObjectPosition(activemarker[0], -3+lane*3,0.7,-30.0)
		activemarker[1]=10
	endif
    
    //Motion
    for i = 0 to units.length
    	motionx as float = 0
    	//XMOTION
    	//Distance from lane
    	motionx = ((-3+lane*3) - GetObjectX(units[i]))/10
    	//ZMOTION
    	motionz as float = 0
    	//Distance from neutral
    	motionz = (-10 - GetObjectZ(units[i]))/10
    	//Maintain distance from friendlies
    	maxrepulsion as float = 0
    	for j = 0 to units.length
    		if j = i then continue
    		repulsion as float = 0
    		repulsion = 1/Sqrt(abs(GetObjectX(units[j])-GetObjectX(units[i]))+abs(GetObjectZ(units[j])-GetObjectZ(units[i])))/10
    		if repulsion > 0.16
    			if GetObjectX(units[j])-GetObjectX(units[i]) > 0
    				motionx = clamp(motionx, -0.15, 0.15-repulsion)
    			else
    				motionx = clamp(motionx, -0.15+repulsion, 0.15)
    			endif
    			if GetObjectZ(units[j])-GetObjectZ(units[i]) > 0
    				motionz = clamp(motionz, -0.15, 0.15-repulsion)
    			else
    				motionz = clamp(motionz, -0.15+repulsion, 0.15)
    			endif
    			
 	  		endif
    	next j
    	//Clamp max speed
    	motionz = clamp(motionz, -0.15, 0.15)
    	motionx = clamp(motionx, -0.15, 0.15)
    	//Commit
    	MoveObjectLocalX(units[i], motionx)
    	MoveObjectLocalZ(units[i], motionz)
    next i
    
    //Animate marker
    if activemarker[1] > 0
    	MoveObjectLocalZ(activemarker[0], 3)
    	activemarker[1] = activemarker[1]-1
    endif
    
    //events generation and processing
    for i = 0 to 4
    	//operation
    	if events[i,0,0] = 0 and events[i,0,1] = 0
    		//process event
    		select events[i,lane+1,0]
    			case 0
    				//do nothing
    			endcase
    			case 1
    				//subtract
    				if units.length < events[i,lane+1,1]
    					for sub = 0 to units.length+1
    						DeleteObject(units[units.length])
    						units.remove()
    					next sub
    				else
    					for sub = 0 to events[i,lane+1,1]-1
    						DeleteObject(units[units.length])
    						units.remove()
    					next sub
    				endif
    			endcase
    			case 2
    				//multiply
    				goal as integer
    				goal = events[i,lane+1,1]*(units.length+1)
    				for mult = units.length+1 to goal-1
    					NewUnit()
    				next mult
    			endcase
    			case 3
    				//divide
    				goal = round((units.length+1)/events[i,lane+1,1])
    				numsub as integer
    				numsub = units.length-goal
    				for div = 0 to numsub
    					DeleteObject(units[units.length])
    					units.remove()
    				next div
    			endcase
    			case 4
    				//add
    				for add = 1 to events[i,lane+1,1]
    					NewUnit()
    				next add
    			endcase
    		endselect
    		//refresh event
    		events[i] = RandomEvent()
    	endif
    	//horde
    	if events[i,0,0] = 0 and events[i,0,1] = 1
    		//subtract
    		if units.length < events[i,lane+1,1]
  				for sub = 0 to units.length+1
					DeleteObject(units[units.length])
  					units.remove()
  				next sub
   				else
   					for sub = 0 to events[i,lane+1,1]
   						DeleteObject(units[units.length])
   						units.remove()
   					next sub
   			endif
    		//refresh event
    		events[i] = RandomEvent()
    	endif
    	//operation
    	if events[i,0,0] < 200 and events[i,0,1] = 0
    		operations as string [4] = ["_","-","X","/","+"]
    		operation as string
    		operation = operations[events[i,1,0]]
    		operation = operation + str(events[i,1,1])
    		SetTextString(1,operation)
    		operation = operations[events[i,2,0]]
    		operation = operation + str(events[i,2,1])
    		SetTextString(2,operation)
    		operation = operations[events[i,3,0]]
    		operation = operation + str(events[i,3,1])
    		SetTextString(3,operation)
    		SetTextPosition(1, 10+events[i,0,0]/1.5, 800-4*events[i,0,0])
    		SetTextPosition(2, 300, 800-4*events[i,0,0])
    		SetTextPosition(3, 590-events[i,0,0]/1.5, 800-4*events[i,0,0])
    	elseif events[i,0,0] < 200
    		//hide ops
    		SetTextString(1,"")
    		SetTextString(2,"")
    		SetTextString(3,"")
    	endif
    	//horde
    	if events[i,0,0] = 200 and events[i,0,1] = 1
    		for j = 0 to events[i,1,1]
    			NewHorde(0)
    		next j
    		for j = 0 to events[i,2,1]
    			NewHorde(1)
    		next j
    		for j = 0 to events[i,3,1]
    			NewHorde(2)
    		next j
    	endif
    	//if events[i,0,1] = 1 and events[i,0,0] < 50
    	//	for j = 0 to horde.length
    	//		motionx = (-3+lane*3) - GetObjectX(horde[j])/10
    	//		motionx = clamp(motionx,-0.15,0.15)
    	//		MoveObjectLocalX(horde[j], motionx)
    	//	next j
    	//endif
    	for j = 0 to horde.length
    		MoveObjectLocalZ(horde[j], -0.030)
    		if GetObjectZ(horde[j]) < -15
    			DeleteObject(horde[j])
    			horde.remove(j)
    		endif
    	next j
    	//decrement counter
    	events[i,0,0] = events[i,0,0] - 1
    next i
    
    Printc("FPS: ")
    Print(Round(1/GetFrameTime()))
    Printc("Units: ")
    Print(units.length+1)
loop